<template>
  <el-form
    ref="manualCryptoCurrencyDepositFormRef"
    label-position="left"
    :model="manualCryptoCurrencyDepositFormData"
    :rules="manualCryptoCurrencyDepositRules"
    :validate-on-rule-change="false"
    label-width="210px"
    class="p-6"
  >
    <h4>{{ $t("from") }}</h4>
    <el-form-item :label="$t('wallet_type')" prop="walletType">
      <el-select
        v-model="manualCryptoCurrencyDepositFormData.walletType"
        id="depositWalletType"
        class="w-full"
      >
        <el-option
          v-for="player in playerCryptocurrencyOptions"
          :key="player"
          :label="player.WalletType"
          :value="player.WalletType"
        />
      </el-select>
    </el-form-item>
    <el-form-item :label="$t('your_wallet_address')" prop="playerWalletAddress">
      <el-input
        v-model="manualCryptoCurrencyDepositFormData.playerWalletAddress"
        id="depositWarlletAddress"
        oninput="this.value = this.value.replace(/[^a-zA-Z0-9]/g, '')"
        type="text"
      />
    </el-form-item>
    <el-form-item :label="$t('amount')" prop="amount">
      <el-input
        v-model="manualCryptoCurrencyDepositFormData.amount"
        :placeholder="amountPlaceholder"
        type="text"
        id="depositAmount"
        @input="onInputValue($event, manualCryptoCurrencyDepositFormData, 'amount')"
      >
        <template v-if="checkedCurrency" #append>
          <span>000</span>
        </template>
      </el-input>
      <span v-if="checkedCurrency" class="order-1 text-xs fc-hint mt-3">{{
        $t(
          `deposit_amount_shown_by_the_system_${profile.Currency.toLowerCase()}`
        )
      }}</span>
    </el-form-item>
    <el-form-item
      v-if="companyFlowSettings.depositTimeSetting"
      :label="$t('deposit_time')"
      prop="depositTime"
    >
      <el-date-picker
        v-model="manualCryptoCurrencyDepositFormData.depositTime"
        type="datetime"
        id="depositTime"
        format="YYYY-MM-DD h:mm:ss A"
      />
    </el-form-item>
    <el-form-item
      v-if="companyFlowSettings.slipUploadSetting"
      :label="$t('slip_image')"
      prop="slipUpload"
    >
      <el-upload
        ref="uploadSlipImageFRef"
        v-model="manualCryptoCurrencyDepositFormData.slipUpload"
        class="upload-demo w-full"
        accept=".jpg, .png, .jpeg, .svg"
        :limit="1"
        :on-exceed="handleSlipImageExceed"
        :on-change="getSlipImage"
        :on-remove="removeSlipImage"
        :auto-upload="false"
        id="depositSlipUpload"
      >
        <el-button plain round type="primary">{{
          $t("choose_file")
        }}</el-button>
      </el-upload>
    </el-form-item>
    <h4>{{ $t("to") }}</h4>
    <el-form-item :label="$t('company_channel')">
      <el-select
        v-model="manualCryptoCurrencyDepositFormData.companyBankId"
        class="w-full"
        id="depositCompanyChannel"
      >
        <el-option
          v-for="company in companyCryptocurrencyOptions"
          :key="company.Id"
          :label="company.CompanyChannel"
          :value="company.Id"
        />
      </el-select>
    </el-form-item>
    <el-form-item :label="$t('deposit_address')" prop="cryptoDepositAddress" class="isDisabled-container">
      <el-input
        v-model="manualCryptoCurrencyDepositFormData.cryptoDepositAddress"
        type="text"
        :disabled="true"
        class="green-peru-deposit-address"
        id="depositAddress"
      >
        <template #append>
          <el-button
            type="primary"
            @click="
              copyTextToClipBoard(
                manualCryptoCurrencyDepositFormData.cryptoDepositAddress
              )
            "
          >
            {{ $t("copy") }}
          </el-button>
        </template>
      </el-input>
    </el-form-item>
    <div class="w-full flex justify-center items-center">
      <div class="bg-white p-2 rounded">
        <qrcode-vue
          :value="manualCryptoCurrencyDepositFormData.cryptoDepositAddress"
          :size="120"
        ></qrcode-vue>
      </div>
    </div>
    <div class="text-center mt-10">
      <el-button
        v-if="isUploadImage"
        :disabled="isUploadImage"
        type="primary"
        round
        @click="
          submitManualCryptoCurrencyDeposit(manualCryptoCurrencyDepositFormRef)
        "
        >{{ $t("waiting_upload_image") }}</el-button
      >
      <el-button
        v-else-if="isProccesing"
        :disabled="isProccesing"
        type="primary"
        round
        @click="
          submitManualCryptoCurrencyDeposit(manualCryptoCurrencyDepositFormRef)
        "
        >{{ $t("submit") }}</el-button
      >
      <el-button
        v-else
        type="primary"
        round
        @click="
          submitManualCryptoCurrencyDeposit(manualCryptoCurrencyDepositFormRef)
        "
        >{{ $t("submit") }}</el-button
      >
    </div>
  </el-form>
</template>
<script lang="ts">
import { defineComponent, PropType, toRefs } from "vue";
import QrcodeVue from "qrcode.vue";
import commonHelper from "@/utils/commonHelper";
import { ProfileDto } from "@/models/getProfileResponse";
import { IGetManualCryptoCurrencyTransactionResponse } from "@/models/getManualCryptoCurrencyTransactionResponse";

export default defineComponent({
  components: {
    QrcodeVue,
  },
  props: {
    manualCryptoCurrency: {
      type: Object as PropType<IGetManualCryptoCurrencyTransactionResponse>,
      required: true,
    },
    profile: {
      type: Object as PropType<ProfileDto>,
      required: true,
    },
  },
  setup(props) {
    const { manualCryptoCurrency, profile } = toRefs(props);

    const {
      getSlipImage,
      removeSlipImage,
      uploadSlipImageFRef,
      copyTextToClipBoard,
      handleSlipImageExceed,
      onInputValue,
    } = commonHelper;

    const {
      checkedCurrency,
      playerCryptocurrencyOptions: PlayerCryptocurrencyOptions,
      companyCryptocurrencyOptions: CompanyCryptocurrencyOptions,
      manualCryptoDepositMin,
      manualCryptoDepositMax,
      manualCryptoCurrencyDepositFormRef,
      manualCryptoCurrencyDepositFormData,
      manualCryptoCurrencyDepositRules,
      submitManualCryptoCurrencyDeposit,
      isProccesing,
      isUploadImage,
      companyFlowSettings,
      amountPlaceholder,
    } = useManualCryptoCurrencyDeposit(manualCryptoCurrency, profile);
    return {
      copyTextToClipBoard,
      checkedCurrency,
      playerCryptocurrencyOptions: PlayerCryptocurrencyOptions,
      companyCryptocurrencyOptions: CompanyCryptocurrencyOptions,
      manualCryptoDepositMin,
      manualCryptoDepositMax,
      manualCryptoCurrencyDepositFormRef,
      manualCryptoCurrencyDepositFormData,
      manualCryptoCurrencyDepositRules,
      submitManualCryptoCurrencyDeposit,
      handleSlipImageExceed,
      uploadSlipImageFRef,
      getSlipImage,
      removeSlipImage,
      isProccesing,
      isUploadImage,
      companyFlowSettings,
      amountPlaceholder,
      onInputValue,
    };
  },
});
</script>
<style>
.el-date-editor {
  --el-date-editor-width: 100%;
}
[theme-color="peru_green"] .green-peru-deposit-address .el-input__wrapper {
  width: 98%;
}
</style>
